#include <stdio.h>

  /* Binomni koeficijenti - rekurzivno.

     Koristi globalni (static) brojac poziva
     koji se automatski inicijalizira na 0
     prilikom deklaracije.
  */

long int broj_poziva;


    /* Rekurzivni binomni koeficijent.
       Funkcija ocekuje da su n i k korektno zadani,
       tj. n >= 0, i 0 <= k <= n, tako da NEMA provjere greske. */

int binom(int n, int k)
{
        /* Povecaj globalni brojac poziva. */
    ++broj_poziva;

        /* Provjera granica za prekid rekurzije. */
    if (k == 0 || k == n) return 1;

        /* Rekurzija zbrajanjem iz Pascalovog trokuta. */
    return binom(n - 1, k) + binom(n - 1, k - 1) ;
}


    /* Glavni program cita n i ispisuje sve binomne koeficijente
       (n, k), za k = 0, ..., n i pripadne brojace poziva. */

int main(void)
{
    int n, k;

    printf(" Unesite prirodni broj n: ");
    scanf("%d", &n);
    printf("\n");

    for (k = 0; k <= n; ++k) {
        broj_poziva = 0;

        printf(" (%2d, %2d) = %10d,    broj poziva = %10ld\n",
               n, k, binom(n, k), broj_poziva);
    }

    return 0;
}
