#include <stdio.h>
#include <stdlib.h>
#include <math.h>

  /* Usporedba obicnog i binarnog potenciranja i funkcije pow iz <math.h>.
     Test za x = 1 + 10^(-9) i n = 10^9. */

    /* Obicno potenciranje x^n. */

double int_pow_mul(double x, int n)
{
    double pot = 1.0;
    int neg, i;

        /* Provjera x = 0. */
    if (x == 0.0) return 0.0;

        /* Zapamti predznak od n. */
    neg = n < 0;
    n = abs(n);

        /* Potenciranje mnozenjem. */
    for (i = 1; i <= n; ++i)
        pot *= x;

    if (neg) pot = 1.0 / pot;
    return pot;
}

    /* Binarno potenciranje x^n. */

double int_pow_bin(double x, int n)
{
    double pot = 1.0, b = x;
    int neg;

        /* Provjera x = 0. */
    if (x == 0.0) return 0.0;

        /* Zapamti predznak od n. */
    neg = n < 0;
    n = abs(n);

        /* Potenciranje kvadriranjem i mnozenjem. */
    while (n > 0) {
        if (n % 2 == 1) pot *= b;
        n /= 2;
        if (n > 0) b *= b;
    }

    if (neg) pot = 1.0 / pot;
    return pot;
}

int main(void)
{
    double x = 1.000000001;
    int n = 1000000000;

    printf(" Potencija %11.9f na %2d = %11.9f\n",
           x, n, int_pow_mul(x, n) );
    printf(" Potencija %11.9f na %2d = %11.9f\n",
           x, n, int_pow_bin(x, n) );
    printf(" Potencija %11.9f na %2d = %11.9f\n",
           x, n, pow(x, n) );

    return 0;
}
