  /* Vjezbe: Zadatak 10.1.10. (str. 114), modificiran

     Napisite funkciju koja dobiva prirodni broj n i vraca
     broj razlicitih prostih faktora tog broja, s tim da svaki faktor
     broji samo jednom.
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).
  */

  /* Glavni program testira najbrze tri funkcije - za zadani broj max_n,
     ispisuje zbroj vrijednosti funkcije za brojeve od 2 do max_n.

     Dodana je stoperica (v. Prog2, zadnje predavanje) i ispis vremena.
  */

#include <stdio.h>
#include <math.h>
#include <time.h>


    /* Funkcija za procesorsko vrijeme u sekundama. */

double dsecnd (void) {
    return (double)( clock( ) ) / CLOCKS_PER_SEC;
}


    /* Najbrze tri funkcije za broj razlicitih prostih djelitelja broja. */

int broj_prost_fakt_3(int n)
{
        /* Testira redom faktore od n, pocev od 2, do
           max_d = (int) sqrt(n), i dijeli ih iz n. */

    int br_pfakt = 0;
    int d, max_d;

        /* Brojevi <= 1 nemaju proste faktore (ignoriramo <= 0). */
    if (n <= 1) return 0;

        /* Petlja po svim mogucim faktorima od n, pocev od 2,
           do najvise max_d = (int) sqrt(n).
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    max_d = (int) sqrt(n);

        /* Petlja po mogucim faktorima od n od 2 do max_d. */
    for (d = 2; d <= max_d; ++d)
        if (n % d == 0) {
                /* Obrada prostog faktora d, samo jednom. */
            ++br_pfakt;

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);
        }

        /* Ako je preostali kvocijent u n > 1, i to je prosti faktor. */
    if (n > 1)
            /* Obrada prostog faktora n, samo jednom. */
        ++br_pfakt;

    return br_pfakt;
}


int broj_prost_fakt_4(int n)
{
        /* Testira redom faktore od n, pocev od 2, do
           max_d = (int) sqrt(n), i dijeli ih iz n, uz popravak max_d. */

    int br_pfakt = 0;
    int d, max_d;

        /* Brojevi <= 1 nemaju proste faktore (ignoriramo <= 0). */
    if (n <= 1) return 0;

        /* Petlja po svim mogucim faktorima od n, pocev od 2,
           do najvise max_d = (int) sqrt(n).
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    max_d = (int) sqrt(n);

        /* Petlja po mogucim faktorima od n od 2 do max_d. */
    for (d = 2; d <= max_d; ++d)
        if (n % d == 0) {
                /* Obrada prostog faktora d, samo jednom. */
            ++br_pfakt;

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);

                /* Popravi max_d prema trenutnom n. */
            max_d = (int) sqrt(n);
        }

        /* Ako je preostali kvocijent u n > 1, i to je prosti faktor. */
    if (n > 1)
            /* Obrada prostog faktora n, samo jednom. */
        ++br_pfakt;

    return br_pfakt;
}


int broj_prost_fakt_5(int n)
{
        /* Testira redom faktore od n, pocev od 2, a onda po neparnim do
           max_d = (int) sqrt(n), i dijeli ih iz n, uz popravak max_d. */

    int br_pfakt = 0;
    int d, max_d;

        /* Brojevi <= 1 nemaju proste faktore (ignoriramo <= 0). */
    if (n <= 1) return 0;

        /* Gornja granica za faktor je max_d = (int) sqrt(n). */

    max_d = (int) sqrt(n);

        /* Prvo testiramo faktor 2, podijelimo ga iz broja
           i popravimo granicu. */

    if (2 <= max_d && n % 2 == 0) {
            /* Obrada prostog faktora 2, samo jednom. */
        ++br_pfakt;

            /* Dijeli n s 2, sve dok je djeljiv. */
        do
            n /= 2;
        while (n % 2 == 0);

            /* Popravi max_d prema trenutnom n. */
        max_d = (int) sqrt(n);
    }

        /* Petlja po svim mogucim neparnim faktorima od n, pocev od 3,
           do najvise max_d = (int) sqrt(n).
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    for (d = 3; d <= max_d; d += 2)
        if (n % d == 0) {
                /* Obrada prostog faktora d, samo jednom. */
            ++br_pfakt;

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);

                /* Popravi max_d prema trenutnom n. */
            max_d = (int) sqrt(n);
        }

        /* Ako je preostali kvocijent u n > 1, i to je prosti faktor. */
    if (n > 1)
            /* Obrada prostog faktora n, samo jednom. */
        ++br_pfakt;

    return br_pfakt;
}



    /* Glavni program za test najbrze tri funkcije:
       Zbraja broj razlicitih prostih faktora za brojeve od 2 do 1000000
       i usput mjeri potrebno procesorsko vrijeme za cijeli racun
       (pogledati Prog2, 12. predavanje). */

int main(void)
{
    int max_n = 1000000;    /* Maksimalni broj n u testu. */
    int n;                  /* Broj cije proste faktore trazimo. */
    int sum_pfakt;          /* Zbroj brojeva prostih faktora. */
    double t1, t2, time;    /* Vremena za stopericu. */


    printf(" Test funkcija za brojanje razlicitih prostih faktora.\n");

        /* Treca funkcija. */

    printf("\n Funkcija  broj_prost_fakt_3:\n");
    printf("   Trazim zbroj brojeva svih razlicitih prostih faktora\n");
    printf("   brojeva od 2 do max_n = %d\n", max_n);
    sum_pfakt = 0;

    t1 = dsecnd( );    /* Pocetak mjerenja vremena. */
    for (n = 2; n <= max_n; ++n)
        sum_pfakt += broj_prost_fakt_3(n);
    t2 = dsecnd( );    /* Kraj mjerenja vremena. */
    time = t2 - t1;

    printf("   Trazeni zbroj brojeva = %d,   vrijeme = %9.6f s\n",
           sum_pfakt, time);

        /* Cetvrta funkcija. */

    printf("\n Funkcija  broj_prost_fakt_4:\n");
    printf("   Trazim zbroj brojeva svih razlicitih prostih faktora\n");
    printf("   brojeva od 2 do max_n = %d\n", max_n);
    sum_pfakt = 0;

    t1 = dsecnd( );    /* Pocetak mjerenja vremena. */
    for (n = 2; n <= max_n; ++n)
        sum_pfakt += broj_prost_fakt_4(n);
    t2 = dsecnd( );    /* Kraj mjerenja vremena. */
    time = t2 - t1;

    printf("   Trazeni zbroj brojeva = %d,   vrijeme = %9.6f s\n",
           sum_pfakt, time);

        /* Peta funkcija. */

    printf("\n Funkcija  broj_prost_fakt_5:\n");
    printf("   Trazim zbroj brojeva svih razlicitih prostih faktora\n");
    printf("   brojeva od 2 do max_n = %d\n", max_n);
    sum_pfakt = 0;

    t1 = dsecnd( );    /* Pocetak mjerenja vremena. */
    for (n = 2; n <= max_n; ++n)
        sum_pfakt += broj_prost_fakt_5(n);
    t2 = dsecnd( );    /* Kraj mjerenja vremena. */
    time = t2 - t1;

    printf("   Trazeni zbroj brojeva = %d,   vrijeme = %9.6f s\n",
           sum_pfakt, time);

    return 0;
}
