  /* Vjezbe: Zadatak 10.1.10. (str. 114), modificiran

     Napisite funkciju koja dobiva prirodni broj n i vraca
     broj razlicitih prostih faktora tog broja, s tim da svaki faktor
     broji samo jednom.
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).
  */

  /* Treca varijanta funkcije --- dijeljenje broja uz granicu za faktore:
       - nalazi redom faktore, pocev od 2, do najvise (int) sqrt(n),
         i dijeli ih iz n,
       - na kraju, ako je preostali kvocijent > 1, obradi i njega
         kao prosti faktor.

     Glavni program testira funkciju za ucitani broj n.
  */

#include <stdio.h>
#include <math.h>


    /* Funckija za broj razlicitih prostih djelitelja broja. */

int broj_prost_fakt_3(int n)
{
        /* Testira redom faktore od n, pocev od 2, do
           max_d = (int) sqrt(n), i dijeli ih iz n. */

    int br_pfakt = 0;
    int d, max_d;

        /* Brojevi <= 1 nemaju proste faktore (ignoriramo <= 0). */
    if (n <= 1) return 0;

        /* Petlja po svim mogucim faktorima od n, pocev od 2,
           do najvise max_d = (int) sqrt(n).
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    max_d = (int) sqrt(n);

        /* Petlja po mogucim faktorima od n od 2 do max_d. */
    for (d = 2; d <= max_d; ++d)
        if (n % d == 0) {
                /* Obrada prostog faktora d, samo jednom. */
            ++br_pfakt;

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);
        }

        /* Ako je preostali kvocijent u n > 1, i to je prosti faktor. */
    if (n > 1)
            /* Obrada prostog faktora n, samo jednom. */
        ++br_pfakt;

    return br_pfakt;
}


int main(void)
{
    int n;

    printf(" Upisi broj n: ");
    scanf("%d", &n);

    printf("\n Broj razlicitih prostih faktora od %d je %d\n",
           n, broj_prost_fakt_3(n));

    return 0;
}
