#include <stdio.h>

  /* Binarno pretrazivanje - Zadatak 1.
     Ima samo jednu usporedbu u petlji i jos jednu na kraju.

     Ovdje se "cuva" LIJEVI rub intervala, tj. srednji element
     ulazi u DESNI dio (kao LIJEVI rub), a lijevi dio je bez srednjeg.
     Zavrsna usporedba je s elementom x[l].

     Ova varijanta NE radi dobro! Razlog = racunanje indeksa srednjeg (i)
     zaokruzuje prema dolje. Kad ostanemo na samo dva elementa, tj. za
     d = l + 1, dobivamo i = l. To rezultira beskonacnom petljom,
     ako je elt >= x[i] = x[l]. */

int binary_search_1_l(int x[], int n, int elt)
{
    int l = 0, d = n - 1, i;

    while (l < d) {          /* Strogo manje! */
        i = (l + d) / 2;
        if (elt < x[i])
            d = i - 1;
        else                 /* elt >= x[i] */
            l = i;           /* Ne: i + 1.  */
    }

    return (elt == x[l]);
}

int main(void)
{
    int n, elt, nasao;
    int x[] = {12, 18, 42, 44, 55, 67, 94};

    n = 7;

    printf("\n Upisi broj koji trazis u polju\n");
    scanf("%d", &elt);

    nasao = binary_search_1_l(x, n, elt);

    if (nasao)
        printf(" U polju x nasao element %d\n", elt);
    else
        printf(" U polju x nema elementa %d\n", elt);

    return 0;
}
